import { ProgressDialogSink } from "../../Dialogs/Types";
import { SaveSettings, StampCategory } from "../../Models/ViewerTypes";
import { ViewerOptions } from "../../ViewerOptions";
import { ISupportApiBase } from "../ISupportApiBase";
import { OpenDocumentInfo, DocumentModification } from "../types";
import { IWasmModule } from "./IWasmModule";
export declare class WasmSupportApi implements ISupportApiBase {
    clientId: string;
    docInfo: OpenDocumentInfo;
    documentId: string;
    isDocumentShared: boolean;
    isConnected: boolean;
    isOpened: boolean;
    viewerOptions: ViewerOptions;
    wasmModule: IWasmModule;
    viewer: any;
    private _connectPromiseCapability?;
    constructor(args?: any);
    applyOptions(options: any): void;
    setViewer(viewer: any): void;
    canEditAnnotation(annotation?: any | null | undefined): boolean;
    checkDocumentLoader(): Promise<boolean>;
    closeDocumentLoader(): Promise<boolean>;
    close(): Promise<string>;
    connect(lazy?: boolean | undefined): Promise<boolean>;
    dispose(): void;
    getDownloadUrl(filename: string, format: "PDF" | "PNG" | undefined, correlationId: string): string;
    getDownloadUnmodifiedUrl(filename: string): string;
    uploadFiles(fileIds: string[], sink?: ProgressDialogSink): Promise<boolean>;
    getLastError(): Promise<string>;
    getStampCategories(): Promise<StampCategory[]>;
    modify(documentModification: DocumentModification, correlationId: string): Promise<string>;
    openBinary(data: Uint8Array): Promise<void>;
    serverVersion(): Promise<string>;
    setOptions(saveSettings: SaveSettings | undefined, correlationId: string): Promise<string>;
    verifySignature(fieldName: string): Promise<boolean>;
    private _connectInternal;
}
